import numpy as np
import pandas as pd
from sklearn.model_selection import train_test_split

#originalni csv koji se ucitava za y treba da ima samo jednu vrednost, npr. za klasifikaciju 0,1,2,3,4,5, tj. klasu kojoj instanca pripada
def load_dataset(path_train, path_test, CLASSES, save_path,normalize=False,test_size=0.3):
    from sklearn.preprocessing import MinMaxScaler
    # for train
    train = pd.read_csv(path_train,header=0)
    train = train.dropna()
    x_train = train.iloc[:, :-1].values.astype('float32')
    labels_train = train.iloc[:, -1].values.astype('int32')  # last column category
    y_train = np.zeros([labels_train.shape[0], CLASSES])


    #uzimamo koje su kolone
    columns = list(train.columns)

    #menjamo naziv poslednje kolone
    columns[-1] = 'label'

    #dodajemo jos kolona za labele
    for i in range(1,CLASSES):
        columns.append('label'+ str(i))

    for i in range(labels_train.shape[0]):
        y_train[i][labels_train[i]] = 1

    # for test
    test = None
    labels_test = None
    x_test = None
    #!Important we use stratify to use the same proportion of classes in both train and test sets
    if path_test is not None:
        test = pd.read_csv(path_test,header=0)
        test = test.dropna()
        x_test = test.iloc[:, :-1].values.astype('float32')
        labels_test = test.iloc[:, -1].values.astype('int32')
        y_test = np.zeros([labels_test.shape[0], CLASSES])
        for i in range(labels_test.shape[0]):
            y_test[i][labels_test[i]] = 1
    else:

        x_train, x_test, y_train, y_test = train_test_split(x_train, y_train, test_size=test_size,random_state=13,stratify=y_train)

        #cuvamo i dataset
        #pd.concat([x_train,y_train],axis=1).to_csv('train.csv',header=None,columns=None,index=None)
        #pd.concat([x_test, y_test], axis=1).to_csv('test.csv', header=None, columns=None, index=None)
        #pomocni kod za cuvanje train i test data da imamo kasnije

        #stari kod
        #train, test = train_test_split(train, test_size=test_size, random_state=13,stratify=train.iloc[:,-1])
        #print(type(x_train))
        # save the data
        #train.to_csv('train.csv', index=False)
        #test.to_csv('test.csv', index=False)

        # print('Train size: {train}, Test size: {test}'.format(train=x_train.shape[0], test=x_test.shape[0]))
    if normalize:
        scaler = MinMaxScaler()
        x_train = scaler.fit_transform(x_train)
        x_test = scaler.fit_transform(x_test)
        #ovde obratiti paznju, train bi trebao i fit i transofrm a test samo fit prema transofrmu za train
        #x_test = scaler.fit_transform(x_test)
    #print(x_test.shape)
    #print(y_test.shape)
    #print(labels_train.reshape(-1,1).shape)

    #sada cuvamo train i test data u posebnim csv fajlovima
    #obratiti paznju: u sacuvanim csv fajlovima prvi red su nazivi kolona (po defaultu 0-xx)
    # takodje, prva kolona je index csv fajla, pa onda sve ovo obrisati ako cemo ponovo da koristimo
    # a poslednje 2,3,itd kolone su y, u zavisnosti od toga koliko imamo klasa
    # ako imamo 2 klase, 2 kolone su y (0,1), (1,0), itd.
    pd.DataFrame(np.concatenate((x_train,y_train),axis=1)).to_csv(save_path+'/train.csv',index=False,header=columns)
    pd.DataFrame(np.concatenate((x_test, y_test), axis=1)).to_csv(save_path+'/test.csv',index=False,header=columns)

    #print(y_test)
    return x_train, y_train, x_test, y_test